Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs	(revision 15509)
@@ -338,157 +108,547 @@
   }
 
-  #region Primitive Value Types
-  [Transformer("268617FE-3F0F-4029-8248-EDA420901FB6", 10000)]
-  [StorableType("320cba58-1aaf-492b-be3b-f59eea085ebe")]
-  internal sealed class ObjectTransformer : BoxTransformer<object> {
-    protected override void Populate(Box.Builder box, object value, Mapper mapper) { }
-    protected override object Extract(Box box, Type type, Mapper mapper) { return new object(); }
-  }
-
-  [Transformer("9FA1C6A8-517E-4623-AC1B-7E9AEF6ED13D", 200)]
-  [StorableType("be3c6d74-5c67-4a54-ab3c-f1040795d364")]
-  internal sealed class BoolTransformer : BoolBoxTransformer<bool> {
-    protected override bool ToBoxType(bool value, Mapper mapper) { return value; }
-    protected override bool ToValueType(bool value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("059633E9-12CB-43EC-8544-57746536E281", 201)]
-  [StorableType("3f1e111d-3ea8-4318-884f-185ef96bdfe4")]
-  internal sealed class ByteTransformer : UnsignedIntBoxTransformer<byte> {
-    protected override uint ToBoxType(byte value, Mapper mapper) { return value; }
-    protected override byte ToValueType(uint value, Type type, Mapper mapper) { return (byte)value; }
-  }
-
-  [Transformer("5DC2F3AC-0852-4B57-A861-D29CC814A94C", 202)]
-  [StorableType("498da443-43d3-4bc4-9ee9-c41416bb5c6b")]
-  internal sealed class SByteTransformer : IntBoxTransformer<sbyte> {
-    protected override int ToBoxType(sbyte value, Mapper mapper) { return value; }
-    protected override sbyte ToValueType(int value, Type type, Mapper mapper) { return (sbyte)value; }
-  }
-
-  [Transformer("B862E642-A94A-4870-8065-06126A35A9E1", 203)]
-  [StorableType("9f9ea850-1dd5-4dc0-abb5-8e75b22a0ffe")]
-  internal sealed class ShortTransformer : IntBoxTransformer<short> {
-    protected override int ToBoxType(short value, Mapper mapper) { return value; }
-    protected override short ToValueType(int value, Type type, Mapper mapper) { return (short)value; }
-  }
-
-  [Transformer("D1D3062D-F1BB-4189-AE50-D6986E1DEB4E", 204)]
-  [StorableType("4b70fdb5-a2ed-4a08-ab17-10fb5db11ada")]
-  internal sealed class UShortTransformer : UnsignedIntBoxTransformer<ushort> {
-    protected override uint ToBoxType(ushort value, Mapper mapper) { return value; }
-    protected override ushort ToValueType(uint value, Type type, Mapper mapper) { return (ushort)value; }
-  }
-
-  [Transformer("6C444645-3062-4D15-AD01-E6E1B0692A2B", 205)]
-  [StorableType("fdf24c34-7c10-49bb-aad2-a668c1490381")]
-  internal sealed class CharTransformer : UnsignedIntBoxTransformer<char> {
-    protected override uint ToBoxType(char value, Mapper mapper) { return value; }
-    protected override char ToValueType(uint value, Type type, Mapper mapper) { return (char)value; }
-  }
-
-  [Transformer("649E73B2-EFA6-4E01-BCB4-4B29D652C9CB", 206)]
-  [StorableType("0b2bcdf7-5787-4027-acd4-46f5f7641bff")]
-  internal sealed class IntTransformer : IntBoxTransformer<int> {
-    protected override int ToBoxType(int value, Mapper mapper) { return value; }
-    protected override int ToValueType(int value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("BCF25010-81A2-49BC-88CC-407D3F393D5B", 207)]
-  [StorableType("eec933ec-f705-435e-9b7e-e4fc4d90c21e")]
-  internal sealed class UIntTransformer : UnsignedIntBoxTransformer<uint> {
-    protected override uint ToBoxType(uint value, Mapper mapper) { return value; }
-    protected override uint ToValueType(uint value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("B6F6ACAE-755C-47EE-B8BF-7CDECBE19C30", 208)]
-  [StorableType("b0edffdd-8a00-48e1-a7a1-808ddec3b933")]
-  internal sealed class LongTransformer : LongBoxTransformer<long> {
-    protected override long ToBoxType(long value, Mapper mapper) { return value; }
-    protected override long ToValueType(long value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("82333ACA-F041-44E0-B365-27C399594BA7", 209)]
-  [StorableType("0ebd1d6b-aa2d-442b-b524-68558d77e22e")]
-  internal sealed class ULongTransformer : UnsignedLongBoxTransformer<ulong> {
-    protected override ulong ToBoxType(ulong value, Mapper mapper) { return value; }
-    protected override ulong ToValueType(ulong value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("8FE91ECF-2261-4934-BECD-C38923B7A703", 210)]
-  [StorableType("d9f05b32-218f-4b8e-9ec7-ab5dcbbaf0fc")]
-  internal sealed class FloatTransformer : FloatBoxTransformer<float> {
-    protected override float ToBoxType(float value, Mapper mapper) { return value; }
-    protected override float ToValueType(float value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("070D23EA-7F38-46B7-A667-219BEF914E49", 211)]
-  [StorableType("70b79b46-2713-42ac-ace6-a55ffb0624be")]
-  internal sealed class DoubleTransformer : DoubleBoxTransformer<double> {
-    protected override double ToBoxType(double value, Mapper mapper) { return value; }
-    protected override double ToValueType(double value, Type type, Mapper mapper) { return value; }
-  }
-
-  [Transformer("BA55C7A6-C91E-4351-A889-E4A7E647F16D", 212)]
-  [StorableType("4ed946fd-aac8-407b-bb9e-093048024d15")]
-  internal sealed class DateTimeTransformer : LongBoxTransformer<DateTime> {
-    protected override long ToBoxType(DateTime value, Mapper mapper) { return value.Ticks; }
-    protected override DateTime ToValueType(long value, Type type, Mapper mapper) { return new DateTime(value); }
-  }
-
-  [Transformer("0C91441B-2D97-432B-B493-D6EC483FC5AD", 213)]
-  [StorableType("bbc20151-b695-43dc-a38a-a610c8410fd2")]
-  internal sealed class TimeSpanTransformer : LongBoxTransformer<TimeSpan> {
-    protected override long ToBoxType(TimeSpan value, Mapper mapper) { return value.Ticks; }
-    protected override TimeSpan ToValueType(long value, Type type, Mapper mapper) { return new TimeSpan(value); }
-  }
-
-  [Transformer("2E6D4A40-B4BE-425F-8E35-2D7C00054639", 215)]
-  [StorableType("11a33d00-5edc-4c49-884a-9f2809c23b30")]
-  internal sealed class PointTransformer : IntArrayBoxTransformer<Point> {
-    protected override IEnumerable<int> ToBoxType(Point value, Mapper mapper) { return new int[] { value.X, value.Y }; }
-    protected override Point ToValueType(IEnumerable<int> value, Type type, Mapper mapper) { return new Point(value.ElementAt(0), value.ElementAt(1)); }
-  }
-
-  [Transformer("97B5CFC8-CDFA-4EB5-B4CD-5B3CFA5CD844", 216)]
-  [StorableType("993238c2-a2ed-4e0d-84ae-ad025f2f20f4")]
-  internal sealed class KeyValuePairTransformer : BoxTransformer<object> {
+  [Transformer("4C610596-5234-4C49-998E-30007D64492E", 100)]
+  [StorableType("69870239-00B7-4C9D-AF0B-14208069FAC8")]
+  internal sealed class StringBoxTransformer : BoxTransformer<string> {
+    protected override void Populate(Box box, string value, Mapper mapper) { box.UInt = mapper.GetStringId(value); }
+    protected override string Extract(Box box, Type type, Mapper mapper) { return mapper.GetString(box.UInt); }
+  }
+
+  [Transformer("58E69402-2533-426A-B9B5-9F2EB5241560", 101)]
+  [StorableType("667182BB-D2D5-46C6-97CB-593CE1B19CBC")]
+  internal sealed class BoolBoxTransformer : BoxTransformer<bool> {
+    protected override void Populate(Box box, bool value, Mapper mapper) { box.Bool = value; }
+    protected override bool Extract(Box box, Type type, Mapper mapper) { return box.Bool; }
+  }
+
+  [Transformer("D78F3391-3CAE-4376-9348-7FB38A4DE0EB", 102)]
+  [StorableType("1E75D1D8-3FAD-4D68-86BB-95DE981FDDD2")]
+  internal sealed class IntBoxTransformer : BoxTransformer<int> {
+    protected override void Populate(Box box, int value, Mapper mapper) { box.Int = value; }
+    protected override int Extract(Box box, Type type, Mapper mapper) { return box.Int; }
+  }
+
+  [Transformer("25881263-F452-492E-9FD1-24E1938B048B", 103)]
+  [StorableType("7742A4A3-31B4-4449-9657-0D9F50F2382F")]
+  internal sealed class UIntBoxTransformer : BoxTransformer<uint> {
+    protected override void Populate(Box box, uint value, Mapper mapper) { box.UInt = value; }
+    protected override uint Extract(Box box, Type type, Mapper mapper) { return box.UInt; }
+  }
+
+  [Transformer("F4175165-382B-4B03-921E-5F923510FB1E", 104)]
+  [StorableType("985427E0-E4F0-4182-8D30-63DA7FB69735")]
+  internal sealed class LongBoxTransformer : BoxTransformer<long> {
+    protected override void Populate(Box box, long value, Mapper mapper) { box.Long = value; }
+    protected override long Extract(Box box, Type type, Mapper mapper) { return box.Long; }
+  }
+
+  [Transformer("E8F63973-3C0C-4FA9-B068-40EF4463B30B", 105)]
+  [StorableType("C9F95D84-BCDC-498E-A9AE-7187E483BBBA")]
+  internal sealed class ULongBoxTransformer : BoxTransformer<ulong> {
+    protected override void Populate(Box box, ulong value, Mapper mapper) { box.ULong = value; }
+    protected override ulong Extract(Box box, Type type, Mapper mapper) { return box.ULong; }
+  }
+
+  [Transformer("15489146-EA11-4B90-8020-AF5C10A2531C", 106)]
+  [StorableType("AF1C5176-859C-423B-A2BF-2AEA4D0792C7")]
+  internal sealed class FloatBoxTransformer : BoxTransformer<float> {
+    protected override void Populate(Box box, float value, Mapper mapper) { box.Float = value; }
+    protected override float Extract(Box box, Type type, Mapper mapper) { return box.Float; }
+  }
+
+  [Transformer("91FD51F3-9C47-4944-AC85-273ED0561E87", 107)]
+  [StorableType("4AB25AE9-2600-4041-8F31-C02CCE9A3BEC")]
+  internal sealed class DoubleBoxTransformer : BoxTransformer<double> {
+    protected override void Populate(Box box, double value, Mapper mapper) { box.Double = value; }
+    protected override double Extract(Box box, Type type, Mapper mapper) { return box.Double; }
+  }
+
+  [Transformer("BCB087EA-E477-47EB-9BCE-8C64BAC2F288", 108)]
+  [StorableType("341C2F99-8849-408E-99AA-7700FE0FB789")]
+  internal sealed class ByteBoxTransformer : BoxTransformer<byte> {
+    protected override void Populate(Box box, byte value, Mapper mapper) { box.UInt = value; }
+    protected override byte Extract(Box box, Type type, Mapper mapper) { return (byte)box.UInt; }
+  }
+
+  [Transformer("B90F61D9-75D0-4CAC-AF93-B8C6AB68F642", 109)]
+  [StorableType("FEC52DD5-A422-45C4-995F-09F3B0DEC13F")]
+  internal sealed class SByteBoxTransformer : BoxTransformer<sbyte> {
+    protected override void Populate(Box box, sbyte value, Mapper mapper) { box.Int = value; }
+    protected override sbyte Extract(Box box, Type type, Mapper mapper) { return (sbyte)box.Int; }
+  }
+
+  [Transformer("95EB44A4-EADD-4DA9-B60F-3262FAD6134B", 110)]
+  [StorableType("48744968-15F2-4B22-AAF2-6C0910239384")]
+  internal sealed class ShortBoxTransformer : BoxTransformer<short> {
+    protected override void Populate(Box box, short value, Mapper mapper) { box.Int = value; }
+    protected override short Extract(Box box, Type type, Mapper mapper) { return (short)box.Int; }
+  }
+
+  [Transformer("E3A33614-9120-400E-BAD9-2594F6804DA8", 111)]
+  [StorableType("DCF05BA3-3C57-4DBB-96B4-B2CE31CA60C5")]
+  internal sealed class UShortBoxTransformer : BoxTransformer<ushort> {
+    protected override void Populate(Box box, ushort value, Mapper mapper) { box.Int = value; }
+    protected override ushort Extract(Box box, Type type, Mapper mapper) { return (ushort)box.Int; }
+  }
+
+  [Transformer("C64EA534-E2E1-48F0-86C5-648AA02117BC", 112)]
+  [StorableType("142980B3-A251-48D2-BF02-A66C483D6385")]
+  internal sealed class CharBoxTransformer : BoxTransformer<char> {
+    protected override void Populate(Box box, char value, Mapper mapper) { box.UInt = value; }
+    protected override char Extract(Box box, Type type, Mapper mapper) { return (char)box.UInt; }
+  }
+
+  [Transformer("D50C4782-7211-4476-B50F-7D3378EE3E53", 200)]
+  [StorableType("4397B775-7D48-4C2A-8D28-ACC8C196CF70")]
+  internal sealed class StringArrayBoxTransformer : BoxTransformer<string[]> {
+    protected override void Populate(Box box, string[] value, Mapper mapper) {
+      var unsignedIntArrayBox = new UnsignedIntArrayBox();
+      unsignedIntArrayBox.Values.AddRange(value.Select(mapper.GetStringId));
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(unsignedIntArrayBox);
+    }
+
+    protected override string[] Extract(Box box, Type type, Mapper mapper) {
+      var unsignedIntArrayBox = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      return unsignedIntArrayBox.Values.Select(mapper.GetString).ToArray();
+    }
+  }
+
+  [Transformer("C9CFA67B-DF13-4125-B781-98EC8F5E390F", 201)]
+  [StorableType("9719DB59-C6BC-4788-BBB0-389A1B49CFEE")]
+  internal sealed class BoolArrayBoxTransformer : BoxTransformer<bool[]> {
+    protected override void Populate(Box box, bool[] value, Mapper mapper) {
+      var boolArrayBox = new BoolArrayBox();
+      boolArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetBoolArrayBoxId(boolArrayBox);
+    }
+
+    protected override bool[] Extract(Box box, Type type, Mapper mapper) {
+      var boolArrayBox = mapper.GetBoolArrayBox(box.BoxId);
+      return boolArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("BA2E18F6-5C17-40CA-A5B8-5690C5EFE872", 202)]
+  [StorableType("6548E9F0-621D-47BA-A605-8A47EF85C231")]
+  internal sealed class IntArrayBoxTransformer : BoxTransformer<int[]> {
+    protected override void Populate(Box box, int[] value, Mapper mapper) {
+      var intArrayBox = new IntArrayBox();
+      intArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetIntArrayBoxId(intArrayBox);
+    }
+
+    protected override int[] Extract(Box box, Type type, Mapper mapper) {
+      var intArrayBox = mapper.GetIntArrayBox(box.BoxId);
+      return intArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("EEE7710D-86DE-47E1-887D-BDA2996B141E", 203)]
+  [StorableType("4127B466-AFC0-4050-8C45-1376A0E3E016")]
+  internal sealed class UnsignedIntArrayBoxTransformer : BoxTransformer<uint[]> {
+    protected override void Populate(Box box, uint[] value, Mapper mapper) {
+      var unsignedIntArrayBox = new UnsignedIntArrayBox();
+      unsignedIntArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(unsignedIntArrayBox);
+    }
+
+    protected override uint[] Extract(Box box, Type type, Mapper mapper) {
+      var unsignedIntArrayBox = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      return unsignedIntArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("557932AA-F023-477F-AAD0-5098E8B8CD56", 204)]
+  [StorableType("C2ED50C8-C340-40C1-B00C-2F398EB709A0")]
+  internal sealed class LongArrayBoxTransformer : BoxTransformer<long[]> {
+    protected override void Populate(Box box, long[] value, Mapper mapper) {
+      var longArrayBox = new LongArrayBox();
+      longArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetLongArrayBoxId(longArrayBox);
+    }
+
+    protected override long[] Extract(Box box, Type type, Mapper mapper) {
+      var longArrayBox = mapper.GetLongArrayBox(box.BoxId);
+      return longArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("CFF20DEE-2A55-4D04-B543-A4C7E0A8F7BF", 205)]
+  [StorableType("641AE353-5373-4811-BACB-C13D3144809C")]
+  internal sealed class UnsignedLongArrayBoxTransformer : BoxTransformer<ulong[]> {
+    protected override void Populate(Box box, ulong[] value, Mapper mapper) {
+      var unsignedLongArrayBox = new UnsignedLongArrayBox();
+      unsignedLongArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetUnsignedLongArrayBoxId(unsignedLongArrayBox);
+    }
+
+    protected override ulong[] Extract(Box box, Type type, Mapper mapper) {
+      var unsignedLongArrayBox = mapper.GetUnsignedLongArrayBox(box.BoxId);
+      return unsignedLongArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("2A0F766D-FE71-4415-A75F-A32FB8BB9E2D", 206)]
+  [StorableType("AEE9384F-3857-4CE4-AE30-B99474F7A6C9")]
+  internal sealed class FloatArrayBoxTransformer : BoxTransformer<float[]> {
+    protected override void Populate(Box box, float[] value, Mapper mapper) {
+      var floatArrayBox = new FloatArrayBox();
+      floatArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetFloatArrayBoxId(floatArrayBox);
+    }
+
+    protected override float[] Extract(Box box, Type type, Mapper mapper) {
+      var floatArrayBox = mapper.GetFloatArrayBox(box.BoxId);
+      return floatArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("192A8F7D-84C7-44BF-B0CA-AD387A241AAD", 207)]
+  [StorableType("17D0BA74-CB84-405C-8DBB-D9E361274A0A")]
+  internal sealed class DoubleArrayBoxTransformer : BoxTransformer<double[]> {
+    protected override void Populate(Box box, double[] value, Mapper mapper) {
+      var doubleArrayBox = new DoubleArrayBox();
+      doubleArrayBox.Values.AddRange(value);
+      box.BoxId = mapper.GetDoubleArrayBoxId(doubleArrayBox);
+    }
+
+    protected override double[] Extract(Box box, Type type, Mapper mapper) {
+      var doubleArrayBox = mapper.GetDoubleArrayBox(box.BoxId);
+      return doubleArrayBox.Values.ToArray();
+    }
+  }
+
+  [Transformer("3A35CECE-9953-4C29-A796-A56C02D80A05", 208)]
+  [StorableType("A076D11E-89AA-43C8-87F5-A0D0F52569EB")]
+  internal sealed class ByteArrayBoxTransformer : BoxTransformer<byte[]> {
+    protected override void Populate(Box box, byte[] value, Mapper mapper) {
+      box.Bytes = ByteString.CopyFrom(value);
+    }
+
+    protected override byte[] Extract(Box box, Type type, Mapper mapper) {
+      return box.Bytes.ToArray();
+    }
+  }
+
+  [Transformer("880D4A63-6C77-4F9F-8F7C-2D365F0AE829", 209)]
+  [StorableType("74F6FD4B-D7D7-43CD-B28B-3A775505FEE3")]
+  internal sealed class SByteArrayBoxTransformer : BoxTransformer<sbyte[]> {
+    protected override void Populate(Box box, sbyte[] value, Mapper mapper) {
+      box.Bytes = ByteString.CopyFrom(value.Select(x => (byte)x).ToArray());
+    }
+
+    protected override sbyte[] Extract(Box box, Type type, Mapper mapper) {
+      return box.Bytes.Select(x => (sbyte)x).ToArray();
+    }
+  }
+
+  [Transformer("9786E711-7C1D-4761-BD6B-445793834264", 210)]
+  [StorableType("5F32480E-AACB-4DB3-ADE3-1CF36E33C037")]
+  internal sealed class ShortArrayBoxTransformer : BoxTransformer<short[]> {
+    protected override void Populate(Box box, short[] value, Mapper mapper) {
+      var res = new byte[value.Length * 2];
+      for (int i = 0; i < value.Length; i++) {
+        var bytes = BitConverter.GetBytes(value[i]);
+        Array.Copy(bytes, 0, res, i * 2, 2);
+      }
+      box.Bytes = ByteString.CopyFrom(res);
+    }
+
+    protected override short[] Extract(Box box, Type type, Mapper mapper) {
+      var bytes = box.Bytes.ToArray();
+      var res = new short[bytes.Length / 2];
+      for (int i = 0; i < bytes.Length; i += 2) {
+        res[i / 2] = BitConverter.ToInt16(bytes, i);
+      }
+      return res;
+    }
+  }
+
+  [Transformer("1AAC2625-356C-40BC-8CB4-15CB3D047EB8", 211)]
+  [StorableType("C303B4CF-FFD0-47E2-9D94-07F2D558D17F")]
+  internal sealed class UShortArrayTransformer : BoxTransformer<ushort[]> {
+    protected override void Populate(Box box, ushort[] value, Mapper mapper) {
+      var res = new byte[value.Length * 2];
+      for (int i = 0; i < value.Length; i++) {
+        var bytes = BitConverter.GetBytes(value[i]);
+        Array.Copy(bytes, 0, res, i * 2, 2);
+      }
+      box.Bytes = ByteString.CopyFrom(res);
+    }
+
+    protected override ushort[] Extract(Box box, Type type, Mapper mapper) {
+      var bytes = box.Bytes.ToArray();
+      var res = new ushort[bytes.Length / 2];
+      for (int i = 0; i < bytes.Length; i += 2) {
+        res[i / 2] = BitConverter.ToUInt16(bytes, i);
+      }
+      return res;
+    }
+  }
+
+  [Transformer("12F19098-5D49-4C23-8897-69087F1C146D", 212)]
+  [StorableType("55F7C8B0-F2AA-4830-857D-6CE2807DA138")]
+  internal sealed class CharArrayTransformer : BoxTransformer<char[]> {
+    protected override void Populate(Box box, char[] value, Mapper mapper) {
+      var res = new byte[value.Length * 2];
+      for (int i = 0; i < value.Length; i++) {
+        var bytes = BitConverter.GetBytes(value[i]);
+        Array.Copy(bytes, 0, res, i * 2, 2);
+      }
+      box.Bytes = ByteString.CopyFrom(res);
+    }
+    protected override char[] Extract(Box box, Type type, Mapper mapper) {
+      var bytes = box.Bytes.ToArray();
+      var res = new char[bytes.Length / 2];
+      for (int i = 0; i < bytes.Length; i += 2) {
+        res[i / 2] = BitConverter.ToChar(bytes, i);
+      }
+      return res;
+    }
+  }
+
+  [Transformer("05AE4C5D-4D0C-47C7-B6D5-F04230C6F565", 301)]
+  [StorableType("A74820C8-F400-462A-913A-610BB588D04A")]
+  internal sealed class ArrayBoxTransformer : BoxTransformer<object> {
     public override bool CanTransformType(Type type) {
-      return type.IsGenericType && (type.GetGenericTypeDefinition() == typeof(KeyValuePair<,>));
-    }
-    protected override void Populate(Box.Builder box, object value, Mapper mapper) {
-      var b = UnsignedIntArrayBox.CreateBuilder();
+      return type.IsArray;
+    }
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
       var type = value.GetType();
-      var pair = new uint[2];
-      pair[0] = mapper.GetBoxId(type.GetProperty("Key").GetValue(value));
-      pair[1] = mapper.GetBoxId(type.GetProperty("Value").GetValue(value));
-      b.AddRangeValues(pair);
-      box.SetExtension(UnsignedIntArrayBox.UnsignedIntArray, b.Build());
-    }
+      var array = (Array)value;
+      var rank = array.Rank;
+
+      var uIntArrayBox = new UnsignedIntArrayBox();
+      uIntArrayBox.Values.Add(mapper.GetBoxId(rank));
+
+      int[] lengths = new int[rank];
+      int[] lowerBounds = new int[rank];
+      for (int i = 0; i < rank; i++) {
+        lengths[i] = array.GetLength(i);
+        lowerBounds[i] = array.GetLowerBound(i);
+      }
+
+      uIntArrayBox.Values.AddRange(lengths.Select(x => mapper.GetBoxId(x)));
+      uIntArrayBox.Values.AddRange(lowerBounds.Select(x => mapper.GetBoxId(x)));
+
+      int[] positions = (int[])lowerBounds.Clone();
+      while (positions[rank - 1] < lengths[rank - 1] + lowerBounds[rank - 1]) {
+        uIntArrayBox.Values.Add(mapper.GetBoxId(array.GetValue(positions)));
+        positions[0] += 1;
+        for (int i = 0; i < rank - 1; i++) {
+          if (positions[i] >= lowerBounds[i] + lengths[i]) {
+            positions[i] = lowerBounds[i];
+            positions[i + 1] += 1;
+          } else {
+            break;
+          }
+        }
+      }
+
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(uIntArrayBox);
+    }
+
+    protected override object Extract(Box box, Type type, Mapper mapper) {
+      var uIntArrayBox = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      var rank = (int)mapper.GetObject(uIntArrayBox.Values[0]);
+
+      int[] lengths = new int[rank], lowerBounds = new int[rank];
+      for (int i = 0; i < rank; i++)
+        lengths[i] = (int)mapper.GetObject(uIntArrayBox.Values[i + 1]);
+      for (int i = 0; i < rank; i++)
+        lowerBounds[i] = (int)mapper.GetObject(uIntArrayBox.Values[i + 1 + rank]);
+
+      return Array.CreateInstance(type.GetElementType(), lengths, lowerBounds);
+    }
+
     public override void FillFromBox(object obj, Box box, Mapper mapper) {
-      var b = box.GetExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      var key = mapper.GetObject(b.GetValues(0));
-      var val = mapper.GetObject(b.GetValues(1));
-      var type = obj.GetType();
-      //DataMemberAccessor.GenerateFieldSetter(type.GetField("key", BindingFlags.NonPublic | BindingFlags.Instance))(obj, key);
-      //DataMemberAccessor.GenerateFieldSetter(type.GetField("value", BindingFlags.NonPublic | BindingFlags.Instance))(obj, val);
-      type.GetField("key", BindingFlags.NonPublic | BindingFlags.Instance).SetValue(obj, key);
-      type.GetField("value", BindingFlags.NonPublic | BindingFlags.Instance).SetValue(obj, val);
-    }
+      var array = (Array)obj;
+      var uIntArrayBox = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      var rank = (int)mapper.GetObject(uIntArrayBox.Values[0]);
+
+      int[] lengths = new int[rank], lowerBounds = new int[rank];
+      for (int i = 0; i < rank; i++)
+        lengths[i] = (int)mapper.GetObject(uIntArrayBox.Values[i + 1]);
+      for (int i = 0; i < rank; i++)
+        lowerBounds[i] = (int)mapper.GetObject(uIntArrayBox.Values[i + 1 + rank]);
+
+      int[] positions = (int[])lowerBounds.Clone();
+      var e = uIntArrayBox.Values.Skip(1 + 2 * rank).GetEnumerator();
+      while (e.MoveNext()) {
+        int[] currentPositions = positions;
+        array.SetValue(mapper.GetObject(e.Current), currentPositions);
+        positions[0] += 1;
+        for (int i = 0; i < rank - 1; i++) {
+          if (positions[i] >= lengths[i] + lowerBounds[i]) {
+            positions[i] = lowerBounds[i];
+            positions[i + 1] += 1;
+          } else {
+            break;
+          }
+        }
+      }
+    }
+  }
+
+  [Transformer("26AD5F85-1D77-4579-BCB9-CD409B48AC7A", 302)]
+  [StorableType("A96E2C1E-EBDF-4D81-A0ED-91677BC84FEE")]
+  internal sealed class EnumerableBoxTransformer : BoxTransformer<object> {
+    private static readonly HashSet<Type> supportedTypes = new HashSet<Type> {
+      typeof(Stack<>), typeof(Stack),
+      typeof(Queue<>), typeof(Queue),
+      typeof(HashSet<>),
+      typeof(List<>), typeof(ArrayList)
+    };
+
+    public override bool CanTransformType(Type type) {
+      return type.IsGenericType && supportedTypes.Contains(type.GetGenericTypeDefinition()) || supportedTypes.Contains(type);
+    }
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
+      var uIntArrayBox = new UnsignedIntArrayBox();
+
+      var type = value.GetType();
+      var propertyInfo = type.GetProperty("Comparer");
+      if (propertyInfo != null) {
+        // TODO: where to store id for comparer box? (atm: first element in int array ...)
+        var comparer = propertyInfo.GetValue(value);
+        var comparerType = comparer.GetType();
+        if (StorableTypeAttribute.IsStorableType(comparerType))
+          uIntArrayBox.Values.Add(mapper.GetBoxId(comparer));
+        else if (comparerType.GetFields(BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.FlattenHierarchy).Any())
+          throw new NotSupportedException("Cannot serialize non-storable equality comparers with fields");
+        else
+          uIntArrayBox.Values.Add(mapper.GetBoxId(comparerType));
+      }
+
+      foreach (var item in (IEnumerable)value)
+        uIntArrayBox.Values.Add(mapper.GetBoxId(item));
+
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(uIntArrayBox);
+    }
+
     protected override object Extract(Box box, Type type, Mapper mapper) {
       return Activator.CreateInstance(type);
     }
-  }
-
-  [Transformer("EBD8BF65-D97D-4FD4-BF4F-9D58A72B6249", 217)]
-  [StorableType("b7725dfa-94fb-4169-b375-6e46b7ca4810")]
-  internal sealed class DecimalTransformer : UnsignedIntBoxTransformer<decimal> {
-    protected override uint ToBoxType(decimal value, Mapper mapper) {
-      return mapper.GetStringId(FormatG30(value));
-    }
-    protected override decimal ToValueType(uint value, Type type, Mapper mapper) {
-      var converter = TypeDescriptor.GetConverter(typeof(Font));
-      return ParseG30(mapper.GetString(value));
-    }
+
+    public override void FillFromBox(object obj, Box box, Mapper mapper) {
+      var uIntArrayBox = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      var elements = uIntArrayBox.Values.Select(mapper.GetObject);
+      var type = obj.GetType();
+
+      string methodName = string.Empty;
+      if (type.IsGenericType && type.GetGenericTypeDefinition() == typeof(Stack<>) || type == typeof(Stack)) {
+        elements = elements.Reverse();
+        methodName = "Push";
+      } else if (type.IsGenericType && type.GetGenericTypeDefinition() == typeof(Queue<>) || type == typeof(Queue)) {
+        methodName = "Enqueue";
+      } else {
+        methodName = "Add";
+        if (type.IsGenericType && type.GetGenericTypeDefinition() == typeof(HashSet<>)) {
+          var fieldInfo = type.GetField("m_comparer", BindingFlags.NonPublic | BindingFlags.Instance);
+          var comparerObj = mapper.GetObject(uIntArrayBox.Values[0]);
+          var comparer = comparerObj is Type ? Activator.CreateInstance((Type)comparerObj) : comparerObj;
+          fieldInfo.SetValue(obj, comparer);
+          elements = elements.Skip(1);
+        }
+      }
+
+      MethodInfo addMethod = type.GetMethod(methodName);
+      foreach (var e in elements)
+        addMethod.Invoke(obj, new[] { e });
+    }
+  }
+
+  [Transformer("C47A62F5-F113-4A43-A8EE-CF817EC799A2", 303)]
+  [StorableType("BA53DF84-DC97-4D8D-A493-868972ED1002")]
+  internal sealed class DictionaryTransformer : BoxTransformer<object> {
+    public override bool CanTransformType(Type type) {
+      return type.IsGenericType && typeof(Dictionary<,>) == type.GetGenericTypeDefinition();
+    }
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
+      var dictionaryBox = new DictionaryBox();
+      foreach (DictionaryEntry item in (IDictionary)value) {
+        dictionaryBox.KeyValuePairs.Add(mapper.GetBoxId(item.Key), mapper.GetBoxId(item.Value));
+      }
+
+      var type = value.GetType();
+      var propertyInfo = type.GetProperty("Comparer");
+      var comparer = propertyInfo.GetValue(value);
+
+      var comparerType = comparer.GetType();
+      if (StorableTypeAttribute.IsStorableType(comparerType))
+        dictionaryBox.ComparerId = mapper.GetBoxId(comparer);
+      else if (comparerType.GetFields(BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.FlattenHierarchy).Any())
+        throw new NotSupportedException("Cannot serialize non-storable equality comparers with fields");
+      else
+        dictionaryBox.ComparerId = mapper.GetBoxId(comparerType);
+
+      box.BoxId = mapper.GetDictionaryBoxId(dictionaryBox);
+    }
+
+    protected override object Extract(Box box, Type type, Mapper mapper) {
+      var dictionaryBox = mapper.GetDictionaryBox(box.BoxId);
+      return Activator.CreateInstance(type, dictionaryBox.KeyValuePairs.Count);
+    }
+
+    public override void FillFromBox(object obj, Box box, Mapper mapper) {
+      var type = obj.GetType();
+      var dictionaryBox = mapper.GetDictionaryBox(box.BoxId);
+      var comparerObj = mapper.GetObject(dictionaryBox.ComparerId);
+      var comparer = comparerObj is Type ? Activator.CreateInstance((Type)comparerObj) : comparerObj;
+
+      var fieldInfo = type.GetField("comparer", BindingFlags.NonPublic | BindingFlags.Instance);
+      fieldInfo.SetValue(obj, comparer);
+
+      var addMethod = type.GetMethod("Add");
+      foreach (var entry in dictionaryBox.KeyValuePairs) {
+        var key = mapper.GetObject(entry.Key);
+        var value = mapper.GetObject(entry.Value);
+        addMethod.Invoke(obj, new[] { key, value });
+      }
+    }
+
+    [Transformer("93FF076B-BC4B-4C39-8C40-15E004468C98", 219)]
+    [StorableType("F8A7DBB4-E1CE-4DB8-905E-F3A05F5CA000")]
+    internal sealed class EnumTransformer : Transformer {
+      public override bool CanTransformType(Type type) {
+        return typeof(Enum).IsAssignableFrom(type);
+      }
+
+      public override Box ToBox(object o, Mapper mapper) {
+        var box = new Box {
+          TransformerId = mapper.GetTransformerId(this),
+          TypeId = mapper.GetStringId(o.GetType().AssemblyQualifiedName),
+          UInt = mapper.GetStringId(Enum.Format(o.GetType(), o, "G")),
+        };
+        return box;
+      }
+
+      public override object ToObject(Box box, Mapper mapper) {
+        return Enum.Parse(Type.GetType(mapper.GetString(box.TypeId)), mapper.GetString(box.UInt));
+      }
+    }
+
+    [Transformer("268617FE-3F0F-4029-8248-EDA420901FB6", 10000)]
+    [StorableType("320CBA58-1AAF-492B-BE3B-F59EEA085EBE")]
+    internal sealed class ObjectBoxTransformer : BoxTransformer<object> {
+      protected override void Populate(Box box, object value, Mapper mapper) { }
+      protected override object Extract(Box box, Type type, Mapper mapper) { return new object(); }
+    }
+  }
+
+  [Transformer("90F9F16D-9F94-491B-AC3B-E1C6F3432127", 400)]
+  [StorableType("C3C23FEE-DB96-4CEA-A38B-6BB73811F877")]
+  internal sealed class DecimalBoxTransformer : BoxTransformer<decimal> {
+    protected override decimal Extract(Box box, Type type, Mapper mapper) {
+      return ParseG30(mapper.GetString(box.UInt));
+    }
+
+    protected override void Populate(Box box, decimal value, Mapper mapper) {
+      box.UInt = mapper.GetStringId(FormatG30(value));
+    }
+
     private static decimal ParseG30(string s) {
       decimal d;
